HW4Q3<-read.table("HW4Q3.txt")

library(mgcv)
library(caret)
library(dplyr)


### Fit a smooth function on cooling.time , production.temp and
### production.pressure, but not on carbon.proportion and
### titanium.proportion. The dataset is fairly small, so fitting a
### model with too many degrees of freedom can be inaccurate.

GAM.Model<-gam(log(tensile.strength)~s(cooling.time)+
                   carbon.proportion+
                   titanium.proportion+
                   s(production.temp)+
                   s(production.pressure),
               data=HW4Q3)

### Random forest is fairly straightforward. On my computer, 500 trees
### does not take long, because it is a small data set. If it is
### slower on your computer, you can try reducing ntree, though I
### doubt that will be necessary.

RF.Model<-train(HW4Q3[,-6],
                HW4Q3[,6],
                trControl=trainControl(method="repeatedcv",number=10,repeats=2),
                tuneGrid=expand.grid(mtry=seq_len(5)),ntree=500)

### Include quadratic terms for the predictors where we fitted smooth
### functions in the GAM above.

GLM.Formula<-log(tensile.strength)~cooling.time+I(cooling.time^2)+
    carbon.proportion+
    titanium.proportion+
    production.temp+I(production.temp^2)+
    production.pressure+I(production.pressure^2)
              

GLM.Model<-lm(GLM.Formula,data=HW4Q3)


GLM.Formula2<-log(tensile.strength)~cooling.time+I(cooling.time^2)+
    carbon.proportion+
    titanium.proportion+
    I(carbon.proportion*titanium.proportion)+
    production.temp+I(production.temp^2)+
    production.pressure+I(production.pressure^2)
              

GLM.Model2<-lm(GLM.Formula2,data=HW4Q3)
